# Pipeline needed to quickly run TF resources in the pipeline. Single stage to speed up testing config.

# TF files needed below:

########################
# Provider.tf

# AWS key / key ID added to GL setting CI var as TF_VAR_AWS_ACCESS_KEY & TF_VAR_AWS_SECRET_ACCESS_KEY

# resource "aws_s3_bucket" "example" {
#   bucket = "<bucket-name>"

#   tags = {
#     Name        = "My bucket"
#     Environment = "Dev"
#   }
# }


# resource "aws_instance" "web" {
#   ami           = "ami-0cd8ad123effa531a"
#   instance_type = "t3.micro"

#   tags = {
#     Name = "HelloWorld"
#   }
# }

# resource "aws_ecr_repository" "foo" {
#   name = "bar"

#   image_scanning_configuration {
#     scan_on_push = true
#   }
      
#   tags = {
#     Name = "HelloWorld"
#   }
# }

# resource "aws_iam_role" "test_role" {
#   name = "test_role"

#   assume_role_policy = jsonencode({
#     Version = "2012-10-17"
#     Statement = [
#       {
#         Action = "sts:AssumeRole"
#         Effect = "Allow"
#         Sid    = ""
#         Principal = {
#           Service = "ec2.amazonaws.com"
#         }
#       },
#     ]
#   })
# }

##################################


image:
  name: hashicorp/terraform:latest
  entrypoint: [""]

before_script:
  - terraform --version
  - terraform init

stages:
  - validate_plan

terraform_validate:
  stage: validate_plan
  script:
    - terraform validate

plan:
  stage: validate_plan
  script:
    - terraform plan